#!/usr/bin/python

from mod_utils          import Choice
from mod_ecu_service    import *

from xml.dom.minidom    import parse
from xml.dom.minidom    import parseString
import xml.dom.minidom

import os

def executeCommand( command, services, elm, path ):
  
  os.system('cls' if os.name == 'nt' else 'clear')    # clear screen
  
  print path
  
  print
  print "Prerequisite :",command.prerequisite 
  print 
  print "name         :",command.name
  print "agcdRef      :",command.agcdRef
  print "codeMR       :",command.codeMR 
  print "type         :",command.type   
  print "label        :",command.label  
  print "serviceID    :",command.serviceID
  print "scenario     :",command.scenario
  
  if len(command.serviceID):
    service = services[command.serviceID]
    print '-'*40
    print 'Request to send:',service.startReq
  else:
    print "\nNothing to send!!!\n"
    ch = raw_input('Press ENTER to exit')
    return
    
  if len(service.params)!=0:
    print "\nThere are parameters. I do not support them!!!\n"
    ch = raw_input('Press ENTER to exit')
    return
    
    
  ch = raw_input('Are you ready to send it? <yes/no>:')
  if ch.lower()!='yes': return
  
  resp = elm.request( service.startReq )

  print "\nRequest was sent\n"
  print "Responce         :", resp
  
  ch = raw_input('Press ENTER to exit')
   

class ecu_command:

  name    = ""
  agcdRef = ""
  codeMR  = ""
  type    = ""
  label   = ""
  prerequisite = ""
  caracter    = {}
  serviceID   = ""
  scenario    = ""
  
  def __init__(self, co, opt, tran ):
  
    self.name = co.getAttribute("name")
    self.agcdRef = co.getAttribute("agcdRef")
    self.codeMR  = co.getAttribute("codeMR")
    self.type  = co.getAttribute("type")
    
    Label = co.getElementsByTagName("Label")
    codetext = Label.item(0).getAttribute("codetext")
    if codetext: 
      self.label = tran[codetext]
    else:
      self.label = ""
      
    Prereq = co.getElementsByTagName("PrerequisiteMessage")
    if Prereq:
      codetext = Prereq.item(0).getAttribute("codetext")
      if codetext: 
        self.prerequisite = tran[codetext]
      else:
        self.prerequisite = ""
    
    scenario_tmp = co.getElementsByTagName("Scenario")
    if scenario_tmp:
      scenario_fc = scenario_tmp.item(0).firstChild
      if scenario_fc:
        self.scenario = scenario_fc.nodeValue
      else: 
        self.scenario = "" 

    self.caracter = {}
    Interpretation = co.getElementsByTagName("StatusInterpretation")
    if Interpretation:
      for cor in Interpretation:
        Correspondance = cor.getElementsByTagName("Correspondance")
        if Correspondance:
          for co in Correspondance:
            ivalue = co.getAttribute("value")            
            codetext  = co.getAttribute("codetext")
            if codetext: 
              itext = tran[codetext]
              self.caracter[ivalue]=itext
    
    if "Command\\"+self.name not in opt.keys(): return
    xmlstr = opt["Command\\"+self.name]
    odom = xml.dom.minidom.parseString( xmlstr.encode( "utf-8" ) )
    odoc = odom.documentElement
    
    self.computation = ""
    ServiceID = odoc.getElementsByTagName("ServiceID")
    if ServiceID:
      for sid in ServiceID:
        self.serviceID = sid.getAttribute("name")

'''    
    print '='*60
    print self.name+" "+self.label
    for l in self.caracter.keys():
      print "\t"+self.caracter[l]
'''

class ecu_commands:
 
  def __init__(self, command_list, mdoc, opt, tran ):
    commands = mdoc.getElementsByTagName("Command")
    if commands:
      for co in commands:
        command = ecu_command( co, opt, tran )
        command_list[command.name] = command
        