#!/usr/bin/python

from mod_utils          import Choice
from xml.dom.minidom    import parse
from xml.dom.minidom    import parseString
import xml.dom.minidom

def get_mnemonicDTC( m, resp ):
  '''This function use synthetic response generated from real one '''
  
  bytes = 1
  bits  = int(m.bitsLength)
  if bits>7:
    bytes = bits/8
  
  hexval = "00"
  sb = int(m.startByte)-1
  if (sb*3+bytes*3-1)>(len(resp)):
    return hexval
  
  hexval = resp[sb*3:(sb+bytes)*3-1]
  hexval = hexval.replace(" ","")
  
  if bits<8:
    val = int(hexval,16)
    val = (val<<int(m.startBit)>>7)&0x01
    hexval = str(val)

  return hexval


def get_mnemonic( m, elm ):
  resp = elm.request( m.request, m.positive )
  #print resp
  #print ' name        ',m.name
  #print ' littleEndian',m.littleEndian  
  #print ' type        ',m.type    		
  #print ' bitsLength  ',m.bitsLength  	
  #print ' serviceID   ',m.serviceID  	
  #print ' startByte   ',m.startByte, type( m.startByte )	
  #print ' startBit    ',m.startBit  	
  #print ' request     ',m.request       
  #print ' nextDelay   ',m.nextDelay     
  #print ' rOffset     ',m.rOffset 		
  
  bytes = 1
  bits  = int(m.bitsLength)
  if bits>7:
    bytes = bits/8
  
  hexval = "00"
  if len(m.startByte)==0: m.startByte = u'01'
  sb = int(m.startByte)-1
  if (sb*3+bytes*3-1)>(len(resp)):
    return hexval
  
  hexval = resp[sb*3:(sb+bytes)*3-1]
  hexval = hexval.replace(" ","")
  
  if bits<8:
    val = int(hexval,16)
    val = (val<<int(m.startBit)>>7)&0x01
    hexval = str(val)

  return hexval

class ecu_mnemonic:

  name      	= ""
  littleEndian  = ""
  type    		= ""
  bitsLength  	= ""
  serviceID  	= ""
  startByte 	= ""
  startBit  	= ""
  request       = ""
  nextDelay     = ""
  rOffset 		= ""
  positive      = ""
    
  def __init__(self, sv, opt ):
    self.name  = sv.getAttribute("name")
    
    #print '*'*60
    #print sv.toprettyxml()


    MnemoDatas = sv.getElementsByTagName("MnemoDatas").item(0)
    if MnemoDatas:
      self.littleEndian = MnemoDatas.getAttribute("littleEndian")
      self.type         = MnemoDatas.getAttribute("type")
      self.bitsLength   = MnemoDatas.getAttribute("bitsLength")
      #print "type=",self.type

    ServiceID = sv.getElementsByTagName("ServiceID").item(0)
    if ServiceID:
      self.serviceID = ServiceID.getAttribute("name")
    
      srvxmlstr = opt["Service\\"+self.serviceID]
      sdom = xml.dom.minidom.parseString( srvxmlstr.encode( "utf-8" ) )
      sdoc = sdom.documentElement
      
      Start = sdoc.getElementsByTagName("Start").item(0)
      if Start:
        Request = sdoc.getElementsByTagName("Request").item(0)
        if Request:
          self.request = Request.getAttribute("val")
          self.nextDelay = Request.getAttribute("nextDelay")
        
      MnemoLocation = sdoc.getElementsByTagName("MnemoLocation")
      for m in MnemoLocation:
        if m.getAttribute("name") == self.name:
          self.startByte = m.getAttribute("startByte")
          self.startBit = m.getAttribute("startBit")
          self.rOffset = m.getAttribute("rOffset")

      self.positive = ""
      
      Simple = sdoc.getElementsByTagName("Simple").item(0)
      if Simple:
        self.positive = Simple.getAttribute("val")
        #print "positive", self.positive
        return
           
      RepeatInProgress = sdoc.getElementsByTagName("RepeatInProgress").item(0)
      if RepeatInProgress:
        self.positive = RepeatInProgress.getAttribute("val")
        #print "positive", self.positive
        return
  
  
class ecu_mnemonics:
 
  def __init__(self, mnemonic_list, mdoc, opt, tran ):
    
    for k in opt.keys():
      if "Mnemonic" in k:
        xmlstr = opt[k]
        odom = xml.dom.minidom.parseString( xmlstr.encode( "utf-8" ) )
        odoc = odom.documentElement

        mnemonic = ecu_mnemonic( odoc, opt )
        mnemonic_list[mnemonic.name] = mnemonic
'''        
    for l in sorted(mnemonic_list.keys()):
      print '='*60
      print ' name        ',mnemonic_list[l].name
      print ' littleEndian',mnemonic_list[l].littleEndian  
      print ' type        ',mnemonic_list[l].type    		
      print ' bitsLength  ',mnemonic_list[l].bitsLength  	
      print ' serviceID   ',mnemonic_list[l].serviceID  	
      print ' startByte   ',mnemonic_list[l].startByte 	
      print ' startBit    ',mnemonic_list[l].startBit  	
      print ' request     ',mnemonic_list[l].request       
      print ' nextDelay   ',mnemonic_list[l].nextDelay     
      print ' rOffset     ',mnemonic_list[l].rOffset 		
'''       