#!/usr/bin/python

from mod_utils          import Choice
from xml.dom.minidom    import parse
from xml.dom.minidom    import parseString
import xml.dom.minidom

class ecu_mnemolocation:
  name  = ""
  startByte = 0
  startBit  = 0
  rOffset   = 0
  
  def __init__(self, ml ):
    self.name = ml.getAttribute("name")
    self.startByte = ml.getAttribute("startByte")
    self.startBit  = ml.getAttribute("startBit")
    self.rOffset   = ml.getAttribute("rOffset")

class ecu_service_response:
  val   = ""
  status = 0
  mnemolocations = {}
  
  def __init__(self, sr ):
    self.val = sr.getAttribute("val")
    self.status = sr.getAttribute("status")
    
    self.mnemolocations = {}
    #print "test1_mnemoloc: ",len(self.mnemolocations)
    #print sr.toprettyxml()

    MnemoLocations = sr.getElementsByTagName("MnemoLocation")
    if MnemoLocations:
      for ml in MnemoLocations:
        mnemoloc = ecu_mnemolocation( ml )
        self.mnemolocations[mnemoloc.name] = mnemoloc

class ecu_service:

  id        = ""
  delay     = ""
  mode      = ""
  startReq  = ""
  repeatReq = ""
  startNextDelay   = 0
  repeatNextDelay  = 0
  responces             = {}
  responcesRepeat       = {}
  startRepeatInProgres  = {}
  repeatRepeatInProgres = {}  
  params                = []
    
  def __init__(self, sv ):
    self.id = sv.getAttribute("serviceID")
    self.delay = sv.getAttribute("delay")
    self.mode  = sv.getAttribute("mode")
    
    self.responces = {}
    
    Start = sv.getElementsByTagName("Start")
    if Start:
      for st in Start:
        Request = st.getElementsByTagName("Request").item(0)
        if Request:
          #print Request.toprettyxml()
          self.startReq = Request.getAttribute("val")
          self.startNextDelay = Request.getAttribute("nextDelay")
          
          self.params    = []
          Params = Request.getElementsByTagName("Params").item(0)
          if Params:
            Param = Params.getElementsByTagName("Param")
            if Param:
              for pr in Param:
                parm_dic = {}
                parm_dic["rank"] = pr.getAttribute("rank")
                parm_dic["type"] = pr.getAttribute("type")
                parm_dic["pos"] = pr.getAttribute("pos")
                self.params.append( parm_dic )
        
        Simple = st.getElementsByTagName("Simple").item(0)
        if Simple:
          resp = ecu_service_response( Simple )
          self.responces[resp.val] = resp 
           
        RepeatInProgress = st.getElementsByTagName("RepeatInProgress").item(0)
        if RepeatInProgress:
          resp = ecu_service_response( RepeatInProgress )
          self.responces[resp.val] = resp 
          self.startRepeatInProgres[resp.val] = resp 
  
        Resp = st.getElementsByTagName("Resp")
        if Resp:
          for rsp in Resp:
            resp = ecu_service_response( rsp )
            self.responces[resp.val] = resp 
 
    Repeat = sv.getElementsByTagName("Repeat")
    if Repeat:
      for rep in Repeat:
        Request = rep.getElementsByTagName("Request").item(0)
        if Request:
          self.repeatReq = Request.getAttribute("val")
          self.repeatNextDelay = Request.getAttribute("nextDelay")
        
        Simple = rep.getElementsByTagName("Simple").item(0)
        if Simple:
          resp = ecu_service_response( Simple )
          self.responces[resp.val] = resp 
           
        RepeatInProgress = rep.getElementsByTagName("RepeatInProgress").item(0)
        if RepeatInProgress:
          resp = ecu_service_response( RepeatInProgress )
          self.responces[resp.val] = resp 
          self.repeatRepeatInProgres[resp.val] = resp 
  
        Resp = rep.getElementsByTagName("Resp")
        if Resp:
          for rsp in Resp:
            resp = ecu_service_response( rsp )
            self.responcesRepeat[resp.val] = resp 
    
class ecu_services:
 
  def __init__(self, service_list, mdoc, opt, tran ):
    
    for k in opt.keys():
      if "Service" in k:
        xmlstr = opt[k]
        odom = xml.dom.minidom.parseString( xmlstr.encode( "utf-8" ) )
        odoc = odom.documentElement

        service = ecu_service( odoc )
        service_list[service.id] = service
'''        
    for l in sorted(service_list.keys()):
      print '='*60
      print service_list[l].id+" "+service_list[l].startReq+" "+service_list[l].delay
      for r in service_list[l].responces.keys():
        print "\t"+r+" "+service_list[l].responces[r].status
        for m in service_list[l].responces[r].mnemolocations.keys():
          print "\t\t"+m+"   startByte:    "+service_list[l].responces[r].mnemolocations[m].startByte        
'''    
       