#!/usr/bin/python

from mod_ecu_mnemonic   import *
from mod_utils          import Choice
from xml.dom.minidom    import parse
from xml.dom.minidom    import parseString
import xml.dom.minidom

def get_state( st, mn, elm, calc ):
  comp = st.computation
  comp = comp.replace("&amp;","&")
  for m in sorted(st.mnemolist, key=len, reverse=True):
    hex_val = get_mnemonic( mn[m], elm )
    comp = comp.replace(m, "0x"+hex_val) 
  tmp_val = calc.calculate(comp)
  
  if str(tmp_val).encode("utf-8") in st.caracter.keys():
    st.value = st.caracter[str(tmp_val).encode("utf-8")]
  else:
    st.value = ""
    
  st.value = " "*(16-len(st.value)/2) + st.value
  return "%-5s %-50s %-20s"%(st.name,st.label,st.value), st.helps 

class ecu_state:

  name    = ""
  agcdRef = ""
  codeMR  = ""
  label   = ""
  value   = ""
  type    = ""
  helps       = []
  caracter    = {}
  computation = ""
  mnemolist   = []
  
  def __init__(self, st, opt, tran ):
    self.name = st.getAttribute("name")
    self.agcdRef = st.getAttribute("agcdRef")
    self.codeMR  = st.getAttribute("codeMR")
    
    Label = st.getElementsByTagName("Label")
    codetext = Label.item(0).getAttribute("codetext")
    if codetext: 
      self.label = tran[codetext]
    else:
      self.label = ""
      
    self.helps = []
    Helps = st.getElementsByTagName("Helps")
    if Helps:
      for hl in Helps:
        Lines = hl.getElementsByTagName("Line")
        if Lines:
          for ln in Lines:
            line = ""
            Label = ln.getElementsByTagName("Label")
            if Label:
              for la in Label:
                codetext = la.getAttribute("codetext")
                if codetext: 
                  line = line + tran[codetext]
            self.helps.append(line)

    self.caracter = {}
    Interpretation = st.getElementsByTagName("Interpretation")
    if Interpretation:
      for cor in Interpretation:
        Correspondance = cor.getElementsByTagName("Correspondance")
        if Correspondance:
          for co in Correspondance:
            ivalue = co.getAttribute("value")
            codetext  = co.getAttribute("codetext")
            if codetext: 
              itext = tran[codetext]
              self.caracter[ivalue]=itext
    
    xmlstr = opt["State\\"+self.name]
    odom = xml.dom.minidom.parseString( xmlstr.encode( "utf-8" ) )
    odoc = odom.documentElement
    
    self.computation = ""
    Computation = odoc.getElementsByTagName("Computation")
    if Computation:
      for cmpt in Computation:
        self.type = cmpt.getAttribute("type")
        tmp = cmpt.getElementsByTagName("Value").item(0).firstChild.nodeValue
        self.computation = tmp.replace(" ","").replace("&amp;","&")
        
        self.mnemolist = []
        Mnemo = cmpt.getElementsByTagName("Mnemo")
        if Mnemo:
          for mn in Mnemo:
            self.mnemolist.append(mn.getAttribute("name"))

'''    
    print '='*60
    print self.name+" "+self.label
    print self.computation
    for l in self.mnemolist:
      print "\t"+l
    print '-'*60
    for l in self.helps:
      print l
    print '-'*60
'''

class ecu_states:
 
  def __init__(self, state_list, mdoc, opt, tran ):
    States = mdoc.getElementsByTagName("State")
    if States:
      for st in States:
        state = ecu_state( st, opt, tran )
        state_list[state.name] = state
        